export namespace MeterbusLib {
    export class Frame {
        private _telegram : number[]

        constructor(telegram : number[]) {
            this._telegram = telegram
        }
    }

    export class ControlFrame extends Frame {
        constructor(telegram : number[]) {
            super(telegram)
        }
    }

    export class ShortFrame extends Frame {
        constructor(telegram : number[]) {
            super(telegram)
        }
    }

    export class LongFrame extends Frame {
        constructor(telegram : number[]) {
            super(telegram)
        }
    }

    export class SingleCharFrame extends Frame {
        constructor(telegram : number[]) {
            super(telegram)
        }
    }

    export class Telegram {
        private _hexString : string
        private _telegram : number[]
        private _frame : Frame

        constructor() {
        }
    
        get hexString() : string {
            return this._hexString
        }

        get telegram() : number[] {
            return this._telegram
        }

        get frame() : Frame {
            return this._frame
        }

        fromHexString(hexString : string) {
            this._hexString = hexString
            this._telegram = this._hexString.split(' ').map<number>((val) => {
                return parseInt(val, 16)
            })
        }

        parse() {
            if (this._telegram[0] === 0x68 && this._telegram[1] === 0x03) {
                this._frame = new ControlFrame(this._telegram)
            } else if (this._telegram[0] === 0x68) {
                this._frame = new LongFrame(this._telegram)
            } else if (this._telegram[0] === 0x10) {
                this._frame = new ShortFrame(this._telegram)
            } else if (this._telegram[0] === 0xe5) {
                this._frame = new SingleCharFrame(this._telegram)
            } else {
                throw Error('invalid start char')
            }
        }
    }
}